#............................
# R for Epi. Scratchpad.
# HW is here: https://docs.google.com/document/d/1QXCfSFR6Xt29VCJHXru1aHi_6hAtjPUOeUseL3fDZOM/edit
#............................
# Load packages and files ####
library(tidyverse)
#............................
setwd("B:/20Spring_EPID701_RforEpi/R for epi 2020 data pack/") # Mike's 
#............................

#..................................
# I can math, I swear - Mike ####
#..................................
height = c(64, 72, 70, 67, 73)
weight = c(80, 85, 79, 72, 90)
bmi = weight / (height * 2.54 / 100) ^ 2

hw_df = data.frame(height, weight)
hw_df$bmi = hw_df$weight / (hw_df$height * 2.54 / 100) ^ 2
#..................................

#............................
# Explore dataset ####
#............................
load("births_sm.rdata") # pre-cleaned a bit
dim(births) # 62,370 obs
nrow(births)
summary(births)
head(births, n = 2)
str(births)
class(births)
names(births)

# Average maternal age
table(births$mage) # no 99s in this one; looks safe
mean(births$mage) #oops! :)
mean(births$mage, na.rm=T) # 27.51

# histogram of gest age
hist(births$wksgest) # check help for more params

# Mothers who smoked
table(births$smoker_f)
sum(births$smoker_f == "Smoker", na.rm=T) # 6642 mothers smoked

# age vs wks gest plot
plot(births$mage, births$wksgest) # ewwww
#............................


#............................
# Again, but with csv file
births = read_csv("births2012_small.csv") # fewer columns
names(births) = tolower(names(births)); names(births)

dim(births) # 122,513 records
str(births) # e.g. sex is 1/2.

mean(births$mage) #27.57 doesn't match!
table(births$mage, useNA = "always") # Ah! Has 99s

table(births$cigdur)
sum(births$cigdur == "Y") # 12,951 smoked
#............................

#............................
# Strings ####
#............................
str(births$cigdur)
table(births$cigdur)
names_chr = c("Mike", "Hilary", "Your name")
names_chr %>% typeof

str_length(names_chr) # like nchar()
str_c(names_chr, "'s name") # like paste0()
str_c(names_chr, "s name", sep = "'") # like paste0() or paste()
str_c(names_chr, "s name", sep = "'", collapse = "; ") # ^ ditto
str_flatten(names_chr) # ... and so many more

str_to_lower(names_chr)
str_to_title(names_chr)

# regex ####
str_replace_all(names_chr, "i", "!") # like gsub()
str_split("abc|def|hji", pattern = "\\|", simplify = T) # why \\!
str_view_all("abc|def|hji", pattern = "\\|")
str_detect(names_chr, "m") # like grepl
str_detect(names_chr, "M")
str_count(names_chr, "[aeiou]")
str_view_all(names_chr, "[aeiou]")
str_detect(names_chr, "^[Mm]") # match front
str_view_all(names_chr, "[aeiou]$") # match end
str_view_all(names_chr, "i(.*)$") # . is any char, * repeat
# waaaay more here. See R for DS.

#....................
# Factors ####
#....................
roles = factor(c("student", "faculty", "staff"))
str(roles)
class(roles)
levels(roles)
attributes(roles)
as.numeric(roles)
typeof(roles) 

my_factor = factor(c("a", "b", "c"))
my_factor[2]
my_factor[2] = "d" # Nope!!
str(my_factor)

# baby's birth sex
sex_int = c(1, 2, 1, 2, 3)
sex_f = factor(sex_int, 
               levels = 1:2, labels = c("F", "M"), 
               exclude = 3)
table(sex_int, sex_f, useNA = "always")

table(births$sex)
births$sex_f = factor(births$sex, levels = 1:2, labels = c("F", "M"), exclude = 9) 
table(sex=births$sex, sex_f=births$sex_f, useNA = "always")

# cigdur
table(births$cigdur)
factor(births$cigdur) # better if explicit!
fct_inorder(births$cigdur)
fct_infreq(births$cigdur) # nice for graphs
fct_rev(fct_infreq(births$cigdur))

fct_count(births$cigdur) # nice & short
fct_count(fct_infreq(births$cigdur)) # better

factor(births$cigdur)
fct_relevel(births$cigdur, c("Y", "N", "U"))

# cut is nice for binning continuous values
vals = 1:10
cut(vals, breaks = 3) # ^ works, but prefer more control!
cut(vals, breaks = quantile(vals, 
                            seq(0,1,.25))) # ^ getting more complicated!
cut(vals, breaks = c(0, 3, 6, 10), labels=c("sm", "md", "lg"))

table(births$wksgest)
plot(births$wksgest)
cut(births$wksgest, breaks=c(0, 36, 60))
births$wksgest_f = fct_rev(cut(births$wksgest, 
                               breaks=c(0, 36, 60), 
                               labels = c("Preterm", "Term")))
table(births$wksgest, births$wksgest_f, useNA = "always")
plot(births$wksgest_f)



#....................
# Dates ####
#....................
library(lubridate)

lecturedates_chr = c("2020/01/21", "2020/01/23")
lecturedates_d = as_date(lecturedates_chr)
lecturedates_d = ymd(lecturedates_chr) # safer
lecturedates_d + 1
lecturedates_d + ddays(14)

lecture_days = wday(lecturedates_d + ddays(14), label=T)
plot(lecture_days)

births$dob[1:5]
births$dob[1:5]+1
table(births$dob >= ymd("2012/06/1"))

reprex::reprex()

